/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component.model;
import java.util.List;
/**
 * Jun 30, 2004
 * @author: Tuan Nguyen
 * @email: tuan08@users.sourceforge.net
 * @version: $Id: ListDataHandler.java,v 1.6 2004/11/03 04:24:53 tuan08 Exp $
 */
abstract public class ListDataHandler implements DataHandler {
  protected List datas_;
  protected int currentRow_;
  
  public ListDataHandler() {

  }

  public ListDataHandler setDatas(List datas) {
    datas_ = datas;
    return this;
  }

  public void begin() {
    currentRow_ = -1;
  }

  public void end() {
  }

  public boolean nextRow() {
    currentRow_++;
    if (datas_ != null) {
      if (currentRow_ < datas_.size()) {
        setCurrentObject(datas_.get(currentRow_));
        return true;
      }
    }
    return false;
  }

  public int getCurrentRow() { return currentRow_; }

  public Object getCurrentObject() {  return datas_.get(currentRow_); }

  public String getCurrentObjectId() {  return null;  }

  public Object getObject(int index) {  return datas_.get(index); }
  
  public List getDatas() { return datas_ ; }
}