/***************************************************************************

 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *

 * Please look at license.txt in info directory for more license detail.   *

 **************************************************************************/

package org.exoplatform.portlet.faces.renderer;

import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlet.faces.component.UIPortletPreferences;
import org.exoplatform.portlet.faces.component.UIPreferencesForm;

import javax.faces.component.UIComponent;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.io.IOException;
import java.util.ResourceBundle;


public class PortletPreferencesRenderer extends HtmlBasicRenderer {

  static String DEFAULT_HELP_MESSAGE = 
    "Help message is not available. To customize this message, add the message to "+
    " the portlet resource properties file with the key: info.portlet-preferences-help-info";

  public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
    UIPortletPreferences uiPrefs = (UIPortletPreferences) component ;
    ExternalContext econtext = context.getExternalContext() ;
    ResourceBundle res = getApplicationResourceBundle(econtext) ;
    String helpMessage = DEFAULT_HELP_MESSAGE ;
    try {
      helpMessage = res.getString("info.portlet-preferences-help-info") ;
    } catch (Exception ex) {}

    ResponseWriter w = context.getResponseWriter() ;
    w.write("<table class='portlet-preferences' border='0' cellspacing='2'>") ;
    w.  write("<tr>");
    w.    write("<td>");
    addPreferencesForm(w, uiPrefs) ;
    w.    write("</td>");
    w.    write("<td style='solid 1px black' valign='top'>");
    w.write(helpMessage) ;
    w.    write("</td>");
    w.  write("</tr>");
    w.write("</table>");
  }

  private void addPreferencesForm(ResponseWriter w, UIPortletPreferences uiPrefs) throws IOException {
    UIPreferencesForm form = (UIPreferencesForm) uiPrefs.getChildComponentOfType(UIPreferencesForm.class);
    w.write("<fieldset><legend>Preferences</legend>");
    FacesContext context = FacesContext.getCurrentInstance();
    form.encodeBegin(context);
    form.encodeChildren(context);
    form.encodeEnd(context);
    w.write("</fieldset>");
  }

}

